VERSION 5.00
Begin VB.Form UserManualExampleB 
   Caption         =   "2602 User Manual Demo Program"
   ClientHeight    =   11295
   ClientLeft      =   315
   ClientTop       =   1935
   ClientWidth     =   13065
   LinkTopic       =   "Form3"
   ScaleHeight     =   11295
   ScaleWidth      =   13065
   Begin VB.TextBox txtScript 
      Height          =   4575
      Left            =   1440
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   23
      Top             =   6480
      Width           =   11295
   End
   Begin VB.TextBox txtData 
      Height          =   2655
      Left            =   9480
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   21
      Top             =   2760
      Width           =   3255
   End
   Begin VB.Frame fraScripts 
      Caption         =   "Run using scripts"
      Height          =   2775
      Left            =   240
      TabIndex        =   11
      Top             =   2640
      Width           =   8415
      Begin VB.CheckBox chkDisplayPrompts 
         Caption         =   "Display Prompts"
         Height          =   495
         Left            =   6240
         TabIndex        =   20
         Top             =   1920
         Value           =   1  'Checked
         Width           =   1575
      End
      Begin VB.CommandButton cmdCallFunction_VISA 
         Caption         =   "Call Function (VISA)"
         Height          =   495
         Left            =   2040
         TabIndex        =   19
         Top             =   1920
         Width           =   1575
      End
      Begin VB.CommandButton cmdRunScript_VISA 
         Caption         =   "Run Script (VISA)"
         Height          =   495
         Left            =   2040
         TabIndex        =   18
         Top             =   1200
         Width           =   1575
      End
      Begin VB.CommandButton cmdCallFunction_GPIB 
         Caption         =   "Call Function (GPIB)"
         Height          =   495
         Left            =   240
         TabIndex        =   17
         Top             =   1920
         Width           =   1575
      End
      Begin VB.CommandButton cmdRunScript_GPIB 
         Caption         =   "Run Script (GPIB)"
         Height          =   495
         Left            =   240
         TabIndex        =   16
         Top             =   1200
         Width           =   1575
      End
      Begin VB.CommandButton cmdLoadScript_VISA 
         Caption         =   "Load Script (VISA)"
         Height          =   495
         Left            =   2040
         TabIndex        =   15
         Top             =   480
         Width           =   1575
      End
      Begin VB.CommandButton cmdLoadScript_GPIB 
         Caption         =   "Load Script (GPIB)"
         Height          =   495
         Left            =   240
         TabIndex        =   14
         Top             =   480
         Width           =   1575
      End
      Begin VB.OptionButton optScriptSelect 
         Caption         =   "Load ""Function"" Script"
         Height          =   255
         Index           =   1
         Left            =   6000
         TabIndex        =   13
         Top             =   960
         Width           =   2295
      End
      Begin VB.OptionButton optScriptSelect 
         Caption         =   "Load ""Non-Function"" Script"
         Height          =   255
         Index           =   0
         Left            =   6000
         TabIndex        =   12
         Top             =   480
         Value           =   -1  'True
         Width           =   2295
      End
   End
   Begin VB.Frame fraTraditional 
      Caption         =   "Run like traditional GPIB instrument"
      Height          =   1335
      Left            =   240
      TabIndex        =   8
      Top             =   960
      Width           =   5295
      Begin VB.CommandButton cmdVISA 
         Caption         =   "Run with VISA"
         Height          =   495
         Left            =   1920
         TabIndex        =   10
         Top             =   480
         Width           =   1455
      End
      Begin VB.CommandButton cmdGPIB 
         Caption         =   "Run with GPIB"
         Height          =   495
         Left            =   240
         TabIndex        =   9
         Top             =   480
         Width           =   1455
      End
   End
   Begin VB.TextBox txtStatusDesc 
      Appearance      =   0  'Flat
      Height          =   495
      Left            =   7800
      MultiLine       =   -1  'True
      TabIndex        =   6
      Top             =   5760
      Width           =   4935
   End
   Begin VB.TextBox txtStatusVal 
      Appearance      =   0  'Flat
      Height          =   495
      Left            =   1440
      TabIndex        =   4
      Top             =   5760
      Width           =   4935
   End
   Begin VB.TextBox txtGPIBaddress 
      Height          =   375
      Left            =   7800
      TabIndex        =   1
      Text            =   "26"
      Top             =   1080
      Width           =   1575
   End
   Begin VB.TextBox txtVisaResource 
      Height          =   375
      Left            =   7800
      TabIndex        =   0
      Text            =   "GPIB0::26::INSTR"
      Top             =   1800
      Width           =   1575
   End
   Begin VB.Label Label7 
      AutoSize        =   -1  'True
      Caption         =   "2602 User Manual Demo Program"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   555
      Left            =   4320
      TabIndex        =   25
      Top             =   120
      Width           =   7335
   End
   Begin VB.Image Image1 
      Height          =   555
      Left            =   240
      Picture         =   "UserManualExampleB.frx":0000
      Stretch         =   -1  'True
      Top             =   120
      Width           =   2760
   End
   Begin VB.Label Label5 
      AutoSize        =   -1  'True
      Caption         =   "Script:"
      Height          =   195
      Left            =   840
      TabIndex        =   24
      Top             =   8670
      Width           =   450
   End
   Begin VB.Label Label6 
      AutoSize        =   -1  'True
      Caption         =   "Data:"
      Height          =   195
      Left            =   9000
      TabIndex        =   22
      Top             =   3990
      Width           =   390
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "Status Desc:"
      Height          =   195
      Left            =   6720
      TabIndex        =   7
      Top             =   5880
      Width           =   915
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Status Value:"
      Height          =   195
      Left            =   360
      TabIndex        =   5
      Top             =   5910
      Width           =   945
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "VISA Resource:"
      Height          =   195
      Left            =   6600
      TabIndex        =   3
      Top             =   1890
      Width           =   1140
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "GPIB Address:"
      Height          =   195
      Left            =   6720
      TabIndex        =   2
      Top             =   1170
      Width           =   1035
   End
End
Attribute VB_Name = "UserManualExampleB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const addr% = 26                            ' Integer constant to hold GPIB address
Const VisaResource$ = "GPIB0::26::INSTR"    ' Sting constant to hold VISA Resource ID

Private Sub Delay(sngSeconds)
    
    Dim sngTargetTime As Single

    sngTargetTime = Timer + sngSeconds
    Do While sngTargetTime > Timer
        DoEvents
    Loop
    
End Sub

Private Function udfGetTspResponse() As String

    Dim intNbytes As Integer    ' Actual number of bytes sent by instrument to controller;
    Dim intStatus As Integer    ' Variable to receive GPIB communication status
    Dim strBuffer As String     ' String to hold instrument response
    
    strBuffer = ""
    Call enter(strBuffer, 1024, intNbytes, addr%, intStatus)
    strBuffer = Left(strBuffer, intNbytes)
    
    udfGetTspResponse = strBuffer
    
End Function

Private Function udfGetTspResponse_VISA(ByVal session As ViSession) As String

    Dim status As ViStatus              ' Variable to receive VISA action status
    Dim retCount As Long                ' Number bytes transferred by a VISA write or read function
    Dim strBuffer As String * 256       ' String to hold instrument response; must be fixed length or initialized string
    
    ' session is the VISA session established in the calling subprogram
    
    status = viRead(session, strBuffer, 256, retCount)
    
    udfGetTspResponse_VISA = Left(strBuffer, retCount - 1)  ' Strip off line feed; this also outputs variable
                                                            ' length string instead of fixed length string.
End Function


Private Sub cmdCallFunction_GPIB_Click()

    Dim intNbytes As Integer    ' Actual number of bytes sent by instrument to controller;
    Dim intStatus As Integer    ' Variable to receive GPIB communication status
    Dim strBuffer As String     ' String to hold instrument response
    
    Dim strReturnMessage As String      ' Variable to hold message retrieved from TSP
    
    ' Addr% is declared at theform level

    txtData.Text = ""
    
    If optScriptSelect(1).Value <> True Then Exit Sub
    
    Call send(addr%, "localnode.prompts = 1", intStatus)
    strReturnMessage = udfGetTspResponse()
    
    '************ Call function with ntimes=10 *************

    Call send(addr%, "MeasCurr(10)", intStatus)     ' Take 10 voltage readings

    txtStatusDesc.Text = "Running function..."
    txtStatusDesc.Refresh
    
    Do      ' Get output from function
        
        strReturnMessage = udfGetTspResponse()
        txtData.Text = txtData.Text & strReturnMessage & vbCrLf
        txtData.SelStart = Len(txtData.Text)
        
    Loop Until Left(strReturnMessage, 3) = "TSP"
    
    If strReturnMessage = "TSP?" Then
        
        txtStatusDesc.Text = "Error Occurred"
        Call send(addr%, "print(errorqueue.next()", intStatus)
        strReturnMessage = udfGetTspResponse()  'Should be error message
        txtStatusDesc.Text = txtStatusDesc.Text & strReturnMessage & vbCrLf
                    
    End If
        
    txtStatusDesc.Text = "Testing complete"
    txtStatusDesc.Refresh
        
    Call send(addr%, "localnode.prompts = 0", intStatus)    ' Turn off prompts

End Sub


Private Sub cmdCallFunction_VISA_Click()

    Dim defaultRM As ViSession          ' Variable to hold default Resource Manager handle
    Dim sesn As ViSession               ' Variable to hold Session handle
    Dim status As ViStatus              ' Variable to receive VISA action status
    Dim retCount As Long                ' Number bytes transferred by a VISA write or read function
    Dim strBuffer As String * 256       ' String to hold instrument response; must be fixed length or initialized string
    Dim strCmd As String                ' Command to send to instrument
    
    Dim strReturnMessage As String      ' Variable to hold message retrieved from TSP
    
    ' VisaResource$ is declared at the form level
    
    status = viOpenDefaultRM(defaultRM)                                 ' Open the default VISA Resource Manager
    status = viOpen(defaultRM, VisaResource$, VI_NULL, VI_NULL, sesn)   ' Open a VISA session for device at
    
    txtData.Text = ""
    
    strCmd = "localnode.prompts = 1"
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strReturnMessage = udfGetTspResponse_VISA(sesn)
    
    If optScriptSelect(1).Value <> True Then Exit Sub
    
    '************ Call function with ntimes=10 *************
    
    txtStatusDesc.Text = "Running function..."
    txtStatusDesc.Refresh

    strCmd = "MeasCurr(10)"         ' Call function
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    'strReturnMessage = udfGetTspResponse_VISA(sesn)

    Do      ' Get output from function
        
        strReturnMessage = udfGetTspResponse_VISA(sesn)
        txtData.Text = txtData.Text & strReturnMessage & vbCrLf
        txtData.SelStart = Len(txtData.Text)
        
    Loop Until Left(strReturnMessage, 3) = "TSP"
    
    If strReturnMessage = "TSP?" Then
        
        txtStatusDesc.Text = "Error Occurred"
        strCmd = "print(errorqueue.next()"
        status = viWrite(sesn, strCmd, Len(strCmd), retCount)
        strReturnMessage = udfGetTspResponse_VISA(sesn)
        txtStatusDesc.Text = txtStatusDesc.Text & strReturnMessage & vbCrLf
                    
    End If
        
    txtStatusDesc.Text = "Testing complete"
    txtStatusDesc.Refresh
        
    strCmd = "localnode.prompts = 0"        ' Disable prompts
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    
    viClose (sesn)              ' Close VISA session
    viClose (defaultRM)         ' Close Resource Manager

End Sub

Private Sub cmdGPIB_Click()
    
    Dim intNbytes As Integer    ' Actual number of bytes sent by instrument to controller;
    Dim intStatus As Integer    ' Variable to receive GPIB communication status
    Dim strBuffer As String     ' String to hold instrument response
    
    ' Addr% is declared at the form level
    
    ' Send commmands to instrument; send() subroutine is in ieeevb.bas module
    Call send(addr%, "localnode.prompts = 0", intStatus)    ' Disable prompts (default); operates like "typical" GPIB instrument
    Call send(addr%, "reset()", intStatus)                                      ' Reset SourceMeter to default settings
    Call send(addr%, "display.screen = display.SMUA", intStatus)                ' Set display to show smua source and limit settings
    Call send(addr%, "display.smua.measure.func = display.MEASURE_DCAMPS", intStatus)   ' Set display to show current measurement
    Call send(addr%, "smua.source.func = smua.OUTPUT_DCVOLTS", intStatus)       ' Set source function to DCV
    Call send(addr%, "smua.source.autorangev = smua.AUTORANGE_ON", intStatus)   ' Enable source autorange
    Call send(addr%, "smua.source.levelv = 5", intStatus)                       ' Set source level to 5V
    Call send(addr%, "smua.source.limiti = 0.1", intStatus)                     ' Set current compliance to 100mA
    Call send(addr%, "smua.measure.rangei = 0.1", intStatus)                    ' Set current measurement range to 100mA
    Call send(addr%, "smua.measure.nplc = 1", intStatus)                        ' Set integration time to 1PLC (default)
    Call send(addr%, "smua.source.output = smua.OUTPUT_ON", intStatus)          ' Turn ON smua output
    Call send(addr%, "print(smua.measure.i())", intStatus)                      ' Measure current and put reading in instrument output queue;
                                                                                ' equivalent to using SCPI READ? query to take single reading
    Call send(addr%, "smua.source.output = smua.OUTPUT_OFF", intStatus)         ' Turn OFF smua output
    
    ' Enter response from print command (i.e. the current reading); enter() subroutine is in ieeevb.bas module
    Call enter(strBuffer, 256, intNbytes, addr%, intStatus)
        
    txtData.Text = strBuffer  ' Display strBuffer in Output textbox
    strBuffer = ""
    
End Sub



Private Sub cmdLoadScript_GPIB_Click()

    Dim intNbytes As Integer    ' Actual number of bytes sent by instrument to controller;
    Dim intStatus As Integer    ' Variable to receive GPIB communication status
    Dim strBuffer As String     ' String to hold instrument response

    Dim strReturnMessage As String      ' Variable to hold message retrieved from TSP
    Dim strScriptline As String         ' Variable used to read scriptline from file and send to TSP
    
    ' Addr% is declared at theform level

    'Clear error queue
    Call send(addr%, "errorqueue.clear()", intStatus)
    
    'Leave error messages in queue and enable Error Prompt
    Call send(addr%, "localnode.showerrors = 0", intStatus)
    
    'Turn on prompts; "localnode" is unit being communicated with via GPIB or RS-232
    'Do not do this until ready to start loading and running script.  You need to start
    'handling the prompts as soon as you send this command
    
    Call send(addr%, "localnode.prompts = 1", intStatus)
    strReturnMessage = udfGetTspResponse()              ' Get prompt from TSP
        
    '******************** Read script from file and download to 2602 ********************
    
    txtStatusDesc.Text = "Loading..."
    txtStatusDesc.Refresh
    
    txtScript.Text = ""
    txtData.Text = ""
    
    'Open the script file for sequential input
    
    If optScriptSelect(0).Value = True Then     'Open script file, which does not create a function

        
        Open App.Path & "\" & "MeasCurrScript.tsp" For Input As #1
        
        Call send(addr%, "loadscript MeasCurrScript", intStatus)
        
        strReturnMessage = udfGetTspResponse()
        If chkDisplayPrompts.Value = 1 Then txtScript.Text = txtScript.Text & strReturnMessage & vbCrLf
        
    Else                                        'Open script file, which creates a function
    
        Open App.Path & "\" & "MeasCurrFunctionScript.tsp" For Input As #1
    
        Call send(addr%, "loadscript MeasCurrFunctionScript", intStatus)
        
        strReturnMessage = udfGetTspResponse()
        If chkDisplayPrompts.Value = 1 Then txtScript.Text = txtScript.Text & strReturnMessage & vbCrLf
        
    End If
    
    txtScript.Text = ""     ' Clear Output textbox
    
    'Read the file
    Do While Not EOF(1)                 ' Loop until the end of the script file.
        
        Line Input #1, strScriptline    ' Read a line from the script file.
        txtScript.Text = txtScript.Text & strScriptline & vbCrLf

        'strScriptline = strScriptline ' & LF ' Add a terminator to the script line.
        'Appears CEC GPIB card handles OK - explicit LF not required
        
        Call send(addr%, strScriptline, intStatus)  'Send script line to 2602
        strReturnMessage = udfGetTspResponse()
        If chkDisplayPrompts.Value = 1 Then txtScript.Text = txtScript.Text & strReturnMessage & vbCrLf
        txtScript.SelStart = Len(txtScript.Text)
            
        strReturnMessage = Left(strReturnMessage, 4)
        
        Select Case strReturnMessage
        
            Case ">>>>"         ' Continuation prompt
        
                ' TSP received script line successfully; waiting for next line
                
            Case "TSP>"         ' Ready prompt
        
                ' TSP received script successfully; ready for next command
                Exit Do
                
            Case "TSP?"         ' Error prompt
            
                ' Error occured; handle as desired
                
            Case Else           ' No prompt received
            
                ' Script response was received instead of a shell prompt
                ' Handle as desired
                
        End Select
    
    Loop
    
    Close #1
         
    Call send(addr%, "endscript", intStatus)    ' Tell TSP complete script has been downloaded
    strReturnMessage = udfGetTspResponse()
    If chkDisplayPrompts.Value = 1 Then txtScript.Text = txtScript.Text & strReturnMessage & vbCrLf
    txtScript.SelStart = Len(txtScript.Text)
        
    txtStatusDesc.Text = "Script loaded"
    txtStatusDesc.Refresh
    
        
    Call send(addr%, "localnode.prompts = 0", intStatus)

End Sub



Private Sub cmdLoadScript_VISA_Click()

    Dim defaultRM As ViSession          ' Variable to hold default Resource Manager handle
    Dim sesn As ViSession               ' Variable to hold Session handle
    Dim status As ViStatus              ' Variable to receive VISA action status
    Dim retCount As Long                ' Number bytes transferred by a VISA write or read function
    Dim strCmd As String                ' Command to send to instrument
    
    Dim strReturnMessage As String      ' Variable to hold message retrieved from TSP
    Dim strScriptline As String         ' Variable used to read scriptline from file and send to TSP
    
    ' VisaResource$ is declared at the form level
    
    status = viOpenDefaultRM(defaultRM)                                 ' Open the default VISA Resource Manager
    status = viOpen(defaultRM, VisaResource$, VI_NULL, VI_NULL, sesn)   ' Open a VISA session for device at
                                                                        ' address 26 on GPIB card 1
                                                                        
    ' Send commmands to instrument; send() subroutine is in GPIB_Subroutines Module
    ' Note use of Len(strCmd) in viWrite(); must tell VISA function how many characters are in command string
    
    'Clear error queue
    strCmd = "errorqueue.clear()"
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    
    'Leave error messages in queue and enable Error Prompt
    strCmd = "localnode.showerrors = 0"
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)

    'Turn on prompts; "localnode" is unit being communicated with via GPIB or RS-232
    'Do not do this until ready to start loading and running script.  You need to start
    'handling the prompts as soon as you send this command
    
    strCmd = "localnode.prompts = 1"
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strReturnMessage = udfGetTspResponse_VISA(sesn)             ' Get prompt from TSP

    '******************** Read script from file and download to 2602 ********************
    
    txtStatusDesc.Text = "Loading..."
    txtStatusDesc.Refresh
    
    txtScript.Text = ""
    txtData.Text = ""
    
    'Open the script file for sequential input
    
    If optScriptSelect(0).Value = True Then     'Open script file, which does not create a function

        Open App.Path & "\" & "MeasCurrScript.tsp" For Input As #1
        
        ' Tell TSP you are starting to download a script named "MeasCurrScript"
        strCmd = "loadscript MeasCurrScript"
        status = viWrite(sesn, strCmd, Len(strCmd), retCount)
        strReturnMessage = udfGetTspResponse_VISA(sesn)
        
        If chkDisplayPrompts.Value = 1 Then txtScript.Text = txtScript.Text & strReturnMessage & vbCrLf
        
    Else                                        'Open script file, which creates a function
    
        Open App.Path & "\" & "MeasCurrFunctionScript.tsp" For Input As #1
        
        ' Tell TSP you are starting to download a script named "MeasCurrScript"
        strCmd = "loadscript MeasCurrFunctionScript"
        status = viWrite(sesn, strCmd, Len(strCmd), retCount)
        strReturnMessage = udfGetTspResponse_VISA(sesn)

        If chkDisplayPrompts.Value = 1 Then txtScript.Text = txtScript.Text & strReturnMessage & vbCrLf
        
    End If
    
    txtScript.Text = ""     ' Clear Output textbox
    
    'Read the file
    Do While Not EOF(1)                 ' Loop until the end of the script file.
        
        Line Input #1, strScriptline    ' Read a line from the script file.
        
        If strScriptline = "" Then strScriptline = " "      ' Seems VISA does not like to send zero length strings
        
        txtScript.Text = txtScript.Text & strScriptline & vbCrLf

        strCmd = strScriptline
        status = viWrite(sesn, strCmd, Len(strCmd), retCount)
        strReturnMessage = udfGetTspResponse_VISA(sesn)
        
        If chkDisplayPrompts.Value = 1 Then txtScript.Text = txtScript.Text & strReturnMessage & vbCrLf
        txtScript.SelStart = Len(txtScript.Text)
        
        strReturnMessage = Left(strReturnMessage, 4)
        
        Select Case strReturnMessage
        
            Case ">>>>"         ' Continuation prompt
        
                ' TSP received script line successfully; waiting for next line
                
            Case "TSP>"         ' Ready prompt
        
                ' TSP received script successfully; ready for next command
                Exit Do
                
            Case "TSP?"         ' Error prompt
            
                ' Error occured; handle as desired
                
            Case Else           ' No prompt received
            
                ' Script response was received instead of a shell prompt
                ' Handle as desired
                
        End Select
    
    Loop
    
    Close #1
         
    strCmd = "endscript"                        ' Tell TSP complete script has been downloaded
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strReturnMessage = udfGetTspResponse_VISA(sesn)

    If chkDisplayPrompts.Value = 1 Then txtScript.Text = txtScript.Text & strReturnMessage & vbCrLf
    txtScript.SelStart = Len(txtScript.Text)
        
    txtStatusDesc.Text = "Script loaded"
    txtStatusDesc.Refresh
    
    strCmd = "localnode.prompts = 0"                        ' Disable prompts
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    
    viClose (sesn)              ' Close VISA session
    viClose (defaultRM)         ' Close Resource Manager

End Sub

Private Sub cmdRunScript_GPIB_Click()

    Dim intNbytes As Integer    ' Actual number of bytes sent by instrument to controller;
    Dim intStatus As Integer    ' Variable to receive GPIB communication status
    Dim strBuffer As String     ' String to hold instrument response
    
    Dim strReturnMessage As String      ' Variable to hold message retrieved from TSP
    
    ' Addr% is declared at theform level
    
    txtData.Text = ""
    
    Call send(addr%, "localnode.prompts = 1", intStatus)
    strReturnMessage = udfGetTspResponse()
    
    '************ Run script (if "function" script is run, then it will create functions *************

    If optScriptSelect(0).Value = True Then         ' Run "non-function" script

        Call send(addr%, "MeasCurrScript.run()", intStatus)

    Else                                            ' Run "function" script
        
        Call send(addr%, "MeasCurrFunctionScript.run()", intStatus)
        
    End If

    txtStatusDesc.Text = "Running script..."
    txtStatusDesc.Refresh
    
    Do      ' Get output from script
        
        strReturnMessage = udfGetTspResponse()
        txtData.Text = txtData.Text & strReturnMessage & vbCrLf
        txtData.SelStart = Len(txtData.Text)
        
    Loop Until Left(strReturnMessage, 3) = "TSP"
    
    If strReturnMessage = "TSP?" Then
        
        txtStatusDesc.Text = "Error Occurred"
        Call send(addr%, "print(errorqueue.next()", intStatus)
        strReturnMessage = udfGetTspResponse()  'Should be error message
        txtStatusDesc.Text = txtStatusDesc.Text & strReturnMessage & vbCrLf
                    
    End If
        
    txtStatusDesc.Text = "Testing complete"
    txtStatusDesc.Refresh
        
    Call send(addr%, "localnode.prompts = 0", intStatus)    ' Turn off prompts

End Sub



Private Sub cmdRunScript_VISA_Click()
    
    Dim defaultRM As ViSession          ' Variable to hold default Resource Manager handle
    Dim sesn As ViSession               ' Variable to hold Session handle
    Dim status As ViStatus              ' Variable to receive VISA action status
    Dim retCount As Long                ' Number bytes transferred by a VISA write or read function
    Dim strBuffer As String * 256       ' String to hold instrument response; must be fixed length or initialized string
    Dim strCmd As String                ' Command to send to instrument
    
    Dim strReturnMessage As String      ' Variable to hold message retrieved from TSP
    
    ' VisaResource$ is declared at the form level
    
    status = viOpenDefaultRM(defaultRM)                                 ' Open the default VISA Resource Manager
    status = viOpen(defaultRM, VisaResource$, VI_NULL, VI_NULL, sesn)   ' Open a VISA session for device at
    
    txtData.Text = ""
    
    strCmd = "localnode.prompts = 1"
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strReturnMessage = udfGetTspResponse_VISA(sesn)
    
    '************ Run script (if "function" script is run, then it will create functions *************

    If optScriptSelect(0).Value = True Then     ' Run "non-function" script
     
        ' In command below, ".run()" is optional; can run script just by sending MeasCurrScript().
        ' Note: MeasCurrScript was the name assigned to script with the "loadscript..." command
        
        strCmd = "MeasCurrScript.run()"
        status = viWrite(sesn, strCmd, Len(strCmd), retCount)

    Else                                        ' Run "function" script
        
        strCmd = "MeasCurrFunctionScript.run()"
        status = viWrite(sesn, strCmd, Len(strCmd), retCount)
        
    End If

    txtStatusDesc.Text = "Running script..."
    txtStatusDesc.Refresh
    
    Do      ' Get output from script
        
        strReturnMessage = udfGetTspResponse_VISA(sesn)
        
        txtData.Text = txtData.Text & strReturnMessage & vbCrLf
        txtData.SelStart = Len(txtData.Text)
        
    Loop Until Left(strReturnMessage, 3) = "TSP"
    
    If strReturnMessage = "TSP?" Then
        
        txtStatusDesc.Text = "Error Occurred"
        
        strCmd = "print(errorqueue.next())"
        status = viWrite(sesn, strCmd, Len(strCmd), retCount)
        strReturnMessage = udfGetTspResponse_VISA(sesn)     'Error message
        txtStatusDesc.Text = txtStatusDesc.Text & strReturnMessage & vbCrLf
                    
    End If
        
    txtStatusDesc.Text = "Testing complete"
    txtStatusDesc.Refresh
        
    strCmd = "localnode.prompts = 0"    ' Turn off prompts
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    
    viClose (sesn)              ' Close VISA session
    viClose (defaultRM)         ' Close Resource Manager

End Sub

Private Sub cmdVISA_Click()
    
    Dim defaultRM As ViSession          ' Variable to hold default Resource Manager handle
    Dim sesn As ViSession               ' Variable to hold Session handle
    Dim status As ViStatus              ' Variable to receive VISA action status
    Dim retCount As Long                ' Number bytes transferred by a VISA write or read function
    Dim strBuffer As String * 256       ' String to hold instrument response; must be fixed length or initialized string
    Dim strCmd As String                ' Command to send to instrument
    
    status = viOpenDefaultRM(defaultRM)     ' Open the default VISA Resource Manager
    status = viOpen(defaultRM, VisaResource$, VI_NULL, VI_NULL, sesn)      ' Open a VISA session for device at
                                                                                ' address 26 on GPIB card 1
    ' Send commmands to instrument; send() subroutine is in GPIB_Subroutines Module
    ' Note use of Len(strCmd) in viWrite(); must tell VISA function how many characters are in command string
    
    strCmd = "localnode.prompts = 0"                                ' Disable prompts (default);
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strCmd = "smua.reset()"                                         ' Reset SourceMeter to default settings
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strCmd = "display.screen = display.SMUA"                        ' Set display to show smua source and limit settings
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strCmd = "display.smua.measure.func = display.MEASURE_DCAMPS"   ' Set display to show current measurement
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strCmd = "smua.source.func = smua.OUTPUT_DCVOLTS"               ' Set source function to DCV
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strCmd = "smua.source.autorangev = smua.AUTORANGE_ON"           ' Enable source autorange
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strCmd = "smua.source.levelv = 5"                              ' Set source level to 5V
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strCmd = "smua.source.limiti = 0.1"                             'Set current compliance to 100mA
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strCmd = "smua.measure.rangei = 0.1"                            ' Set current measurement range to 100mA
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strCmd = "smua.measure.nplc = 1"                                ' Set integration time to 1PLC (default)
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strCmd = "smua.source.output = smua.OUTPUT_ON"                  ' Turn ON smua output
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)
    strCmd = "print(smua.measure.i())"                              ' Measure current and put reading in instrument output queue;
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)           ' equivalent to using READ? query to take single reading
    strCmd = "smua.source.output = smua.OUTPUT_OFF"                 ' Turn OFF smua output
    status = viWrite(sesn, strCmd, Len(strCmd), retCount)

    ' Enter response from print command (i.e. the current reading)
    
    status = viRead(sesn, strBuffer, 256, retCount)
    
    strBuffer = Left(strBuffer, retCount - 1)   ' Strip off linefeed from returned value
    
    txtData.Text = strBuffer                  ' Display strBuffer in Output textbox
    strBuffer = ""
       
    viClose (sesn)              ' Close VISA session
    viClose (defaultRM)         ' Close Resource Manager

End Sub


Private Sub Form_Load()

    Call initialize(21, 0)  ' Initialize Keithley (CEC) GPIB card;
                                ' initialize() subroutine is in ieeevb.bas module
                                
    txtGPIBaddress.Text = addr%
    txtVisaResource.Text = VisaResource$
    
    cmdCallFunction_GPIB.Enabled = False
    cmdCallFunction_VISA.Enabled = False

End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    'Make sure VISA resource manager and session are closed
    'viClose (defaultRM) - handled under command buttons instead
 
    
End Sub



Private Sub optScriptSelect_Click(Index As Integer)
    
    Select Case Index
    
        Case 0      ' Load "Non-Function" Script
        
            cmdCallFunction_GPIB.Enabled = False
            cmdCallFunction_VISA.Enabled = False
            
        Case 1      ' Load "Function" Script
        
            cmdCallFunction_GPIB.Enabled = True
            cmdCallFunction_VISA.Enabled = True
            
    End Select
    
End Sub
